/*############################################################################*/  
/** 
Demo2 - Beispielanwendung fr Biokey3000 DLL in Verbindung mit der 
        Fingerprinteinlernstation

Copyright (C)         : Datafox GmbH Geisa/Germany
                        07/2008

Autor                 : Maik Siebrand             @n
Autor                 : Bernd Ottmann             @n


@b AUFGABE:    

- Die Anwendung zeigt mit zwei Funktionen die Mglichkeiten fr das Arbeiten
  mit der Fingerprint-Einlernstation. Zum einen wird kurz gezeigt, wie man ein 
  Firmwareupdate fr das Biometriemodul Biokey3000 durchfhren kann und zum 
  anderen wie man aus einen Menge von Fingerscanns den Besten ermittelt.

- Der Dialog IDD_DEMO2_DIALOG besitzt ein kleines Hauptmenue und fhrt das 
  Firmwareupdate durch. Darber hinaus gibt es die Mglichkeit eine 
  Statusanzeige zu steuern. Mit der Funktion DFBFirmwareUpdateSetCallBack
  kann z.B. eine Balkenanzeige gesteuert werden.

- Der Dialog IDD_BEST_FINGER wird durch das Hauptmenue aufgerufen und benutzt
  die Methode "Test the Best" um die am besten geeignetsten Templates fr die
  Benutzung in den Datafox-Terminals zu ermitteln.

@b KOMMENTARE:

- Dieses Programm ist eine Opensource Anwendung die Kunden von Datafox, die 
  eine Fingerprinteinlernstation erworben haben, uneingeschrnkt benutzen drfen 
  und diese Anregungen in ihre eigenen Applikationen bernehmen knnen.


*/
/*############################################################################*/


// Demo2.cpp : Legt das Klassenverhalten fr die Anwendung fest.
//

#include "stdafx.h"
#include "Demo2.h"
#include "..\DFBiokey3000.h"
#include "Demo2Dlg.h"
#include "DlgBestFinger.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemo2App

BEGIN_MESSAGE_MAP(CDemo2App, CWinApp)
	//{{AFX_MSG_MAP(CDemo2App)
		// HINWEIS - Hier werden Mapping-Makros vom Klassen-Assistenten eingefgt und entfernt.
		//    Innerhalb dieser generierten Quelltextabschnitte NICHTS VERNDERN!
	//}}AFX_MSG
	ON_COMMAND(ID_HELP, CWinApp::OnHelp)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo2App Konstruktion

// Statische Membervariable fuer Zugriff ueber statische Methoden auf diese Klasse
CDemo2App *CDemo2App::m_this = NULL;


CDemo2App::CDemo2App()
{
	// ZU ERLEDIGEN: Hier Code zur Konstruktion einfgen
	// Alle wichtigen Initialisierungen in InitInstance platzieren

}

/////////////////////////////////////////////////////////////////////////////
// Das einzige CDemo2App-Objekt

CDemo2App theApp;

/////////////////////////////////////////////////////////////////////////////
// CDemo2App Initialisierung

/*############################################################################*/
//  FUNKTION:	 InitInstance
/** berschreibung der Funkton InitInstance.

Autor                 : Bernd Ottmann             @n
erstellt am           : 15.07.2008                @n

@return Gibt immer 1 zurck.

@b AUFGABE:    

- berschreibung der Funktion InitInstance um Anwendungsspezifische Aufgaben zu
  erledigen wie Workerthread starten usw..

@b KOMMENTARE:

@b NDERUNG:

@b LAUFZEIT :

@b TEST :

*/
/*############################################################################*/

BOOL CDemo2App::InitInstance()
{
	AfxEnableControlContainer();

	// Standardinitialisierung
	// Wenn Sie diese Funktionen nicht nutzen und die Gre Ihrer fertigen 
	//  ausfhrbaren Datei reduzieren wollen, sollten Sie die nachfolgenden
	//  spezifischen Initialisierungsroutinen, die Sie nicht bentigen, entfernen.

#ifdef _AFXDLL
	Enable3dControls();			// Diese Funktion bei Verwendung von MFC in gemeinsam genutzten DLLs aufrufen
#else
	Enable3dControlsStatic();	// Diese Funktion bei statischen MFC-Anbindungen aufrufen
#endif

	CDemo2Dlg dlg;
	m_pMainWnd = &dlg;

	// Nachrichten zur Datenaktualisierung an Dialoge
	m_thread = NULL;
	m_threadEnd = FALSE;
	m_threadError = 0;
	m_threadCommand = idle;
	m_hWnd = NULL;
  m_pDlg = NULL;

	// Workerthread fuer Kommunikationsaufgaben
	m_thread = AfxBeginThread(WorkerThread, this, THREAD_PRIORITY_NORMAL);

  char error = 0;

  //zuerst Com-Schnittstelle ffnen
  if (!DFBComOpen("COM1")) error = DFBGetLastErrorNum();

  //anschlieend den Biokey3000 initialisieren
  if (!DFBInit(TEMPLATE_FORMAT,50,40,12)) error = DFBGetLastErrorNum();
  //if (!DFBInit(2,50,40,12)) error = DFBGetLastErrorNum();


	int nResponse = dlg.DoModal();
	if (nResponse == IDOK)
	{
		// ZU ERLEDIGEN: Fgen Sie hier Code ein, um ein Schlieen des
		//  Dialogfelds ber OK zu steuern
	}
	else if (nResponse == IDCANCEL)
	{
		// ZU ERLEDIGEN: Fgen Sie hier Code ein, um ein Schlieen des
		//  Dialogfelds ber "Abbrechen" zu steuern
	}

	// Da das Dialogfeld geschlossen wurde, FALSE zurckliefern, so dass wir die
	//  Anwendung verlassen, anstatt das Nachrichtensystem der Anwendung zu starten.
	return FALSE;
}

/*############################################################################*/
//  FUNKTION:	 ExitInstance
/** berschreibung der Funkton ExitInstance.

Autor                 : Bernd Ottmann             @n
erstellt am           : 15.07.2008                @n

@return Gibt immer 1 zurck.

@b AUFGABE:    

- berschreibung der Funktion ExitInstance um Anwendungsspezifische Aufgaben zu
  erledigen wie Workerthread beenden usw..

@b KOMMENTARE:

@b NDERUNG:

@b LAUFZEIT :

@b TEST :

*/
/*############################################################################*/

int CDemo2App::ExitInstance() 
{
	int i;

	// WorkerThread fuer Kommunikation beenden.
	m_threadEnd = TRUE;

	// Wird derzeit noch ein Befehl abgearbeitet?
	for (i=0; i < 10 && m_threadCommand != idle; i++) {

		Sleep(100);
	}

	// Thread umschalten
	Sleep(10);
	
	// Thread Beendigung abwarten (ThreadFunc stellt m_threadEnd auf FALSE)
	for (i=0; (i < 100) && m_threadEnd; i++) {
			
		Sleep(50);
	}

  //am Ende noch die Schnittstelle schlieen
  DFBComClose();

	
	return CWinApp::ExitInstance();
}

/*############################################################################*/
//  FUNKTION:	 MessageToWindow
/** Prft auf angegebenes Fensterhandle und leitet Nachrichten weiter

Autor                 : Bernd Ottmann             @n
erstellt am           : 15.07.2008                @n

@return Gibt den returncode von SendMessage zurck, ansonsten 0

@b AUFGABE:    

- Weiterleitung von Nachrichten bei bestehndem Fensterhandle.

@b KOMMENTARE:
- Der Handle mu vom Befehlsdialog vor Befehlsvergabe gesetzt werden,
  wenn er ber den Befehlsablauf informiert werden soll.

@b NDERUNG:

@b LAUFZEIT :

@b TEST :

*/
/*############################################################################*/

LRESULT CDemo2App::MessageToWindow(WPARAM par1, LPARAM par2)
{
	if (m_hWnd) {

		return ::SendMessage(m_hWnd, WM_THREAD, par1, par2);
	}

	return 0;
}

/*############################################################################*/
//  FUNKTION:	 WorkerThread
/** Hauptroutine des Arbeitsthreads fr die Bedienung der DLL-Funktionen

Autor                 : Bernd Ottmann             @n
erstellt am           : 15.07.2008                @n

@b AUFGABE:    

- Auf abzuarbeitende Befehle prfen und ber die DLL-Funktionen mit dem  
  Biokeymodul kommunizieren und die Befehle abarbeiten.

@b KOMMENTARE:
- Die Dialoge geben dem Workerthread ber die Memebervariable m_threadCommand
  die abzuarbeitenden Befehle. 

@b NDERUNG:


@b LAUFZEIT :
- Startet mit Anwendung und beendet sich auch mit ihr.

@b TEST :

*/
/*############################################################################*/

UINT32 CDemo2App::WorkerThread(LPVOID lpParam)
{
	if (lpParam == NULL) {

		return 0;
	}

	CDemo2App &cmd = *(CDemo2App*)lpParam;
	cmd.m_this = &cmd;
	int res;

	// Solange kein Endsignal
	while (!cmd.m_threadEnd) {

		// Threadkommando auswerten
		if (cmd.m_threadCommand != idle) {

			// Fehlerwert zuruecksetzen
			cmd.m_threadError = 0;

			// Abzuarbeitendes Kommando auswerten
			switch (cmd.m_threadCommand) {
			case Firmwareupdate:
				// Befehlsstart melden
				cmd.MessageToWindow(MSG_COMMAND_START, 0);
				res = cmd.ThreadFirmwareupdate();
				// Befehlsbeendung melden
				cmd.MessageToWindow(MSG_COMMAND_STOP, res);
				break;
			case BestFinger:
				// Befehlsstart melden
				cmd.MessageToWindow(MSG_COMMAND_START, 0);
				res = cmd.ThreadBestFinger();
				// Befehlsbeendung melden
				cmd.MessageToWindow(MSG_COMMAND_STOP, res);
				break;
			default:
				TRACE("(%i): Nicht eingetragenes Threadkommando.\n", cmd.m_threadCommand);
			}

			// Evntl. aufgetretenen Fehler an Dialog senden
			if (cmd.m_threadError != 0) {

				cmd.MessageToWindow(MSG_ERROR, cmd.m_threadError);
			}

			// Kommando ruecksetzen
			cmd.m_threadCommand = idle;
		}

		// Thread Umschalten
		Sleep(50);
	}

	// Thread Beendigung ruecksetzen
	cmd.m_threadEnd = FALSE;

	return 0;
}

/*############################################################################*/
//  FUNKTION:	 ThreadEinfachAusfuehren
/** Firmwareupdate des Fingerprintmoduls Biokey3000

Autor                 : Maik Siebrand             @n
erstellt am           : 15.07.2008                @n

@return FehlerCode nach Beendigung

@b AUFGABE:    

- ffnet einen Fileopendialog und fhrt mit der ausgewhlten Datei ein 
  Firmwareupdate durch.

@b KOMMENTARE:
- Fr eine Statusanzeige kann die Variable 

@b NDERUNG:


@b LAUFZEIT :
- ca. 50 Sekunden

@b TEST :

*/
/*############################################################################*/

int CDemo2App::ThreadFirmwareupdate() 
{
  int  error=0;
  char Version1[6];
  char Version2[6];
  char message[50];
  char Filename[250];

//Bernd
  CDemo2Dlg *dlg = (CDemo2Dlg*)m_pDlg;

	CString str(".\\");
//Bernd
  DFBFirmwareUpdateSetCallBack(dlg->CBFunction);
  m_msg.Format("Sie fhren gerade ein Firmwareupdate durch.");
	MessageToWindow(MSG_INFORMATION, (long)(LPCTSTR)m_msg);

  //Dateinamen mit Pfad bergeben
  str = dlg->m_filePath;
  strcpy(Filename,str);	

  //aktuellen Softwarestand auslesen
  DFBGetSoftwareVersion(Version1);

  //Firmwareupdate starten
  if (!DFBFirmwareUpdate(Filename)) error = DFBGetLastErrorNum();

  //anschlieend den Biokey3000 initialisieren, hier ein paar Beispielwerte
  //TemplateFormat=Idencom Compact Format, SecurityLevel= 50, Quality=40, MinutiaeMin=12
  if (!DFBInit(TEMPLATE_FORMAT,50,40,12)) error = DFBGetLastErrorNum();

  //Wieder Softwareversion auslesen
  DFBGetSoftwareVersion(Version2);
  if (error)
  {    
    m_msg.Format("Beim Update ist ein Fehler aufgetreten");
	  MessageToWindow(MSG_INFORMATION, (long)(LPCTSTR)m_msg);
  }
  else
  {
    sprintf(message,"Sie haben gerade Version %s mit %s ersetzt.",Version1 ,Version2 );
    m_msg.Format(message);
	  MessageToWindow(MSG_INFORMATION, (long)(LPCTSTR)m_msg);
  }
  DFBFirmwareUpdateSetCallBack(NULL);
	return TRUE;
}

int CDemo2App::ThreadBestFinger() 
{

  CDlgBestFinger *dlg = (CDlgBestFinger*)m_pDlg;


  //Einbinden Test Best Finger Funktion
  CallFunctions(dlg->m_fingerCount, dlg->m_fingerScannCount,dlg->m_pid);

	return TRUE;
}


/*############################################################################*/
//  FUNKTION:	 CallFunctions
/** ruft die Unterprogramme fr die Methode "Test the Best" auf

Autor                 : Maik Siebrand             @n
erstellt am           : 15.07.2008                @n

@param[in] FingerCount Anzahl der Finger von einer Person 
@param[in] ScannCount anzahl der Scanns fr den Vergleich von einem Finger


@b AUFGABE:    

- fhrt je nach Anzahl in FingerCount und ScannCount die Methode "Test the Best"
  durch. Zuerst werden mit ScannBestFinger() die Templates eingescannt, 
  anschlieend werden die Templates eines Fingers untereinander verglichen(matching)
  und je Template die Summe der Trefferquoten(Score) gespeichert. Em Ende wird mit
  FindBestFinger() der beste Finger mit der hchsten Trefferquote ermittelt bzw. 
  alle Finger in der Struktur FingerScore sortiert abgelegt. Somit steht fest 
  welche Finger am besten fr das Arbeiten mit dem Fingerprintmodul geeignet sind 
  und das beste Template des Fingers ist ebenfalls ermittelt. Zum Schluss werden die 
  zwei besten Templates im Biokey3000 gespeichert.

@b KOMMENTARE:
- Die Methode "Test the Best" arbeitet anders als der eigentliche Einlernvorgang des 
  Biokey3000 von Idencom. Bei Messungen hat sich herausgestellt, dass gute 
  Scannergebnisse nicht immer gute Matchergebnisse zur Folge haben. Deshalb ist es 
  besser nach dem Kriterium auszuwhlen, nach dem auch der Matchvorgang arbeitet, die 
  Trefferquote (Score). Die erhalte ich aber nur, wenn ich zwei Template miteinander
  vergleiche. Je mehr ich vergleiche umso besser kann ich whlen welcher Scann und 
  welcher Finger mein Favorit fr die Datenbank des Biokey3000 ist. Wir testen also 
  welcher der Beste ist.

@b NDERUNG:

@b LAUFZEIT :

@b TEST :
- 17.07.2008 (MS) keine Fehler festgestellt

*/
/*############################################################################*/

void CallFunctions(unsigned char FingerCount, unsigned char ScannCount, UINT64 PID)
{
  SCANNLIST scanns;
  MATCHLIST match;
  FINGERLIST FingerScore;
  char message[100];
  

  //zuerst die Strukturen mit NULL fllen
  memset(&scanns,0,sizeof(scanns));
  memset(&match,0,sizeof(match));
  memset(&FingerScore,0,sizeof(FingerScore));


  //Alle Finger Scannen
  ScannBestFinger(FingerCount,ScannCount, &scanns );

  //Alle Finger vergleichen
  MatchBestFinger(FingerCount,ScannCount, &scanns, &match);

  //Sortierte Liste mit den geeignetsten Fingern/Templates erstellen
  FindBestFinger( FingerCount,ScannCount, &scanns, &match, &FingerScore);

  //Nachricht vorbereiten und Formatieren
  sprintf(message,"Der beste Finger ist Nr %i \n Der zweitbeste Finger ist Nr %i  ",*(UINT8*)&FingerScore.Score[0].FingerNr+1,*(UINT8*)&FingerScore.Score[1].FingerNr+1);  

  SaveBestFinger(2, &FingerScore, PID);

  //Nachricht ausgeben welcher ist der beste Finger
  theApp.MessageToWindow(MSG_INFORMATION, (long)(LPCTSTR)message);




}


/*############################################################################*/
//  FUNKTION:	 ScannBestFinger
/** scannt Finger ein

Autor                 : Maik Siebrand             @n
erstellt am           : 15.07.2008                @n

@param[in] FingerCount Anzahl der Finger von einer Person 
@param[in] ScannCount anzahl der Scanns fr den Vergleich von einem Finger
@param[out] scanns ist das Array in dem die gescannten Templates abgelegt sind

@b AUFGABE:    
- Fhrt anhand der in FingerCount und ScannCount bergebenen Werte das Scannen und 
  Abspeichern der Fingertemplates durch.

@b KOMMENTARE:

@b NDERUNG:

@b LAUFZEIT :

@b TEST :
- 17.07.2008 (MS) keine Fehler festgestellt

*/
/*############################################################################*/

void ScannBestFinger(unsigned char FingerCount,unsigned char ScannCount, SCANNLIST *scanns )
{

  UINT8 f, fcount;
  UINT8 s, scount;
  char message[100];
  int error = 0;
  unsigned int size = 0;

  //Prfen ob die Maximal erlaubten Parameter nicht berschritten werden, wenn ja neu setzen
  if (FingerCount > FINGER_MAX) fcount = FINGER_MAX;
  else fcount = FingerCount;
  if (ScannCount > SCANN_MAX) scount = SCANN_MAX;
  else scount = ScannCount;

  //Schleifen fr das Scannen der Fingertemplates
  for (f=0;f<fcount;f++)
  {
    for (s=0;s<scount;s++)
    {

      //Vorbereiten des Nachrichtentextes
      sprintf(message,"Finger Nr %i von %i Scann Nr %i von %i",f+1,fcount,s+1,scount);
      
      //Ausgeben der Nachricht
	    theApp.MessageToWindow(MSG_INFORMATION, (long)(LPCTSTR)message);

      //nun einen Finger scannen
      if (!DFBScanFinger(1)) error = DFBGetLastErrorNum();//auf eine Fehlerbehandlung wird im Demo verzichtet

      //size muss gesetzt werden, weil geprft wird ob der Speicher fr das Template ausreichend ist
      //size sollte die Gre des Speicherbereiches haben, damit nichts berschrieben werden kann
      size=TEMPLATE_SIZE;

      //das Template aus dem Biokey3000 holen
      if (!DFBGetTemplate(&size,(UINT8*)&scanns->Scanns[f][s])) error = DFBGetLastErrorNum();

    }
  }



}

/*############################################################################*/
//  FUNKTION:	 MatchBestFinger
/** vergleicht Templates

Autor                 : Maik Siebrand             @n
erstellt am           : 15.07.2008                @n

@param[in] FingerCount Anzahl der Finger von einer Person 
@param[in] ScannCount anzahl der Scanns fr den Vergleich von einem Finger
@param[in] scanns ist das Array in dem die gescannten Templates abgelegt sind
@param[out] match ist das Array in dem die Trefferqote abgelegt wird

@b AUFGABE:    
- Fhrt mit den in scanns enthaltenen Templates Matchvorgnge durch und speichert 
  die Trefferquote in match. In match wird die Summer der Tefferqoten fr ein 
  Template gehalten. Somit ist der hchste Wert in Match auch das Template mit 
  den besten Eigenschaften.
  

@b KOMMENTARE:

@b NDERUNG:

@b LAUFZEIT :

@b TEST :
- 17.07.2008 (MS) keine Fehler festgestellt

*/
/*############################################################################*/

void MatchBestFinger(unsigned char FingerCount,unsigned char ScannCount, SCANNLIST *scanns, MATCHLIST *match)
{

  UINT8 f, fcount;
  UINT8 s, scount;
  UINT8 z;
  char message[100];
  int error = 0;
  unsigned int size = 0;
  unsigned char Score;
  UINT64 PID;
  unsigned char   FID;  

  //Prfen ob die Maximal erlaubten Parameter nicht berschritten werden, wenn ja neu setzen
  if (FingerCount > FINGER_MAX) fcount = FINGER_MAX;
  else fcount = FingerCount;
  if (ScannCount > SCANN_MAX) scount = SCANN_MAX;
  else scount = ScannCount;

  //Nachricht, dass mit dem Prfen der Finger begonnen wurde
  sprintf(message,"Prfe Finger untereinander");  
	theApp.MessageToWindow(MSG_INFORMATION, (long)(LPCTSTR)message);
  

  //Vergleich der Templates untereinander
  for (f = 0 ; f < fcount ; f++)  //Fingerschleife
  {
    for (s = 0 ; s < scount ; s++)  //aeussere Scannschleife
    {
      for (z = 0 ; z < scount ; z++)  //innere Scannschleife
      {
        if (s != z)// nur Matchen wenn wir nicht die gleichen Templates haben
        {
          error = 0;
          PID = 0;//nur bei Verifikation grer NULL
          FID = 0;//nur bei Verifikation grer NULL

          //bertragen von Template in TemplatebufferA des Fingerprintmoduls
          if (!DFBSetTemplate  ( (UINT8*)&scanns->Scanns[f][s],  0)) error = DFBGetLastErrorNum();

          //bertragen von Template in TemplatebufferB des Fingerprintmoduls
          if (!DFBSetTemplate  ( (UINT8*)&scanns->Scanns[f][z],  1)) error = DFBGetLastErrorNum();

          //Starten des Matchvorganges von TemplatebufferA mit TemplatebufferB
          if (!DFBMatchTemplate  ( 1,  1, &Score , (unsigned char*)&PID, &FID)) error = DFBGetLastErrorNum();

          //in Score ist jetzt meine Trefferquote, die kommt gleich mal in mein Array fr die Trefferquote
           match->Score[f][s]+=Score;
 
        }
      }


      //Ausgabe des Bearbeitungsfortschrittes
      sprintf(message,"Prfe Finger untereinander %i %%", (((f*100) / fcount)+(((s+1)*100)/(scount*fcount))));  
	    theApp.MessageToWindow(MSG_INFORMATION, (long)(LPCTSTR)message);    

    }

    //Ausgabe des Bearbeitungsfortschrittes
    sprintf(message,"Prfe Finger untereinander %i %%", (((f+1)*100) / fcount));  
	  theApp.MessageToWindow(MSG_INFORMATION, (long)(LPCTSTR)message);    

  }
}

/*############################################################################*/
//  FUNKTION:	 FindBestFinger
/** sucht den besten Finger und dessen Templates

Autor                 : Maik Siebrand             @n
erstellt am           : 15.07.2008                @n

@param[in] FingerCount Anzahl der Finger von einer Person 
@param[in] ScannCount anzahl der Scanns fr den Vergleich von einem Finger
@param[in] scanns ist das Array in dem die gescannten Templates abgelegt sind
@param[out] match ist das Array in dem die Trefferqote abgelegt wird

@b AUFGABE:    
- Sucht das Template eines Fingers mit der hchsten Summen-Trefferquote aus 
  match und legt die Fingernummer und das Template in FingerScore ab. Anschlieend 
  wird die Liste nach der hchsten Trefferquote sortiert und somit das beste 
  Templates im ersten Datensatz abgespeichert.
  

@b KOMMENTARE:

@b NDERUNG:

@b LAUFZEIT :

@b TEST :
- 17.07.2008 (MS) keine Fehler festgestellt

*/
/*############################################################################*/

void FindBestFinger(unsigned char FingerCount,unsigned char ScannCount, SCANNLIST *scanns, MATCHLIST *match, FINGERLIST *FingerScore)
{

  UINT8 f, fcount;
  UINT8 s, scount;
  int error = 0;
  unsigned int size = 0;
  UINT16 ScoreMax;
  UINT8 FingerNr;
  FINGER TempFinger;
  UINT32 fWert, sWert;

  //Prfen ob die Maximal erlaubten Parameter nicht berschritten werden, wenn ja neu setzen
  if (FingerCount > FINGER_MAX) fcount = FINGER_MAX;
  else fcount = FingerCount;
  if (ScannCount > SCANN_MAX) scount = SCANN_MAX;
  else scount = ScannCount;

  //jetzt von jedem Finger den mit der hchsten Trefferqote auswhlen
  //Vergleich der Templates untereinander
  for (f = 0 ; f < fcount ; f++)  //Fingerschleife
  {
    ScoreMax=0;
    FingerNr=0;

    for (s = 0 ; s < scount ; s++)  //aeussere Scannschleife
    {

       //in Score ist jetzt meine Trefferquote, die kommt gleich mal in mein Array fr die Trefferquote
       if (match->Score[f][s] > ScoreMax) 
       {
         ScoreMax=match->Score[f][s];//in ScoreMax ist immer die grte gefundene Trefferquote
         FingerNr=s;//in FingerNr ist immer der Finger mit der grten Trefferquote
       } 
       else if (match->Score[f][s] == ScoreMax) 
       {
         //Wenn die Trefferquoten gleich sind benutzen wir ein anderes Kriterium um das bessere Template 
         //zu bestimmen. Das Produkt von Anzahl Minuzien und der Qualitt ist ebenso ein Auswahlkriterium
         //fr die Bestimmung des besseren Templates. Untersuchungen haben aber gezeigt, dass das Produkt 
         //allein fr die Auswahl des besten fingertemplates nicht ausreichend ist, der Vergleich der 
         //Trefferquoten ist der beste und sicherste Weg.
         fWert = scanns->Scanns[f][FingerNr].MinutiaeCount * scanns->Scanns[f][FingerNr].Quality;
         sWert = scanns->Scanns[f][s].MinutiaeCount * scanns->Scanns[f][s].Quality;
         if (fWert < sWert) 
         {
           ScoreMax=match->Score[f][s];
           FingerNr=s;

         }


       }
 
      
    }
    
    //bergabe der Werte an die Strucktur
    FingerScore->Score[f].FingerNr=f;
    FingerScore->Score[f].ScannNr=FingerNr;
    FingerScore->Score[f].Score=ScoreMax;
    FingerScore->Score[f].Template = scanns->Scanns[f][FingerNr];


  }

  
  // nun noch die Liste mit den Fingern sortieren, der beste steht an erster Stelle

  for (f = 0 ; f < fcount ; f++)  //aeussere Fingerschleife
  {

    for (s = f ; s < fcount ; s++)  //innere Fingerschleife
    {
      //immer den mit der hchsten Trefferqoten tauschen
      if (FingerScore->Score[f].Score < FingerScore->Score[s].Score) 
      {
        TempFinger = FingerScore->Score[f];
        FingerScore->Score[f] = FingerScore->Score[s];
        FingerScore->Score[s] = TempFinger;

      }
      else if ((FingerScore->Score[f].Score == FingerScore->Score[s].Score) && (f!=s))
      {
        //falls die Trefferquote gleich ist wieder das Produkt aus Anzahl Minuzien und der Qualitt entscheiden lassen
        fWert = FingerScore->Score[f].Template.MinutiaeCount * FingerScore->Score[f].Template.Quality;
        sWert = FingerScore->Score[s].Template.MinutiaeCount * FingerScore->Score[s].Template.Quality;
        if (fWert < sWert) 
        {
          TempFinger = FingerScore->Score[f];
          FingerScore->Score[f] = FingerScore->Score[s];
          FingerScore->Score[s] = TempFinger;

        }


      }

    }
  
  }

}

/*############################################################################*/
//  FUNKTION:	 SaveBestFinger
/** speichert die besten Finger im Biokeymodul ab

Autor                 : Maik Siebrand             @n
erstellt am           : 15.07.2008                @n

@param[in] FingerCount Anzahl der Finger die von einer Person zum Abspeichern benutzt werden sollen
@param[in] FingerScore ist die Liste mit den besten Template je Finger
@param[in] PID ist die Nummer unter der die Templates im Modul abgelegt werden


@b AUFGABE:    

- Speichert die besten Finger aus FingerScore mit der Anzahl FingerCount im 
  Biokey3000 ab.

@b KOMMENTARE:

- Wenn z.b. 2 Finger pro Person in der Datenbank erfasst werden sollen muss man 
  FingerCount = 2 bergeben. Anschlieend kann man mit dem Befehl DFBMatchTemplate()
  eine Identifizierung mit Sensor und Datenbank durchfhren. die Person sollte 
  dann zweifelsfrei erkannt werden.


@b TEST :
- 24.07.2008 (MS) Mit Softwareversion 5.3 funktioniert das Abspeichern mit 
                  Idencom-Standard-Format nicht. Der Fehler liegt hier bei 
                  Idencom. ltere Version funktionieren, allerdings untersttzen
                  die Versionen unter 5.x, also 4.12 und 4.2, das 
                  Idencom-Compact-Format nicht.

*/
/*############################################################################*/

void SaveBestFinger(unsigned char FingerCount, FINGERLIST *FingerScore, UINT64 PID)
{

  UINT8 f, fcount;
  int error = 0;
  unsigned int size = 0;
  FINGER TempFinger;
  TEMPLATE Template1, Template2;
  unsigned char c_PID[8];
  unsigned char c_FID;
  unsigned int BufferLength;
  int Result ;
  unsigned int Templatesize;

  if (TEMPLATE_FORMAT == 0)
  {
    Templatesize = 161;
  }
  else if (TEMPLATE_FORMAT == 1)
  {
    Templatesize = 216;
  } 
  else
  {
    Templatesize = 560;
  } 

  //Prfen ob die Maximal erlaubten Parameter nicht berschritten werden, wenn ja neu setzen
  if (FingerCount > FINGER_MAX) fcount = FINGER_MAX;
  else fcount = FingerCount;

  //PID abfragen

  for (f = 0 ; f < fcount ; f++)  
  {
    
    TempFinger = FingerScore->Score[f];
    TempFinger.Template.FID=TempFinger.FingerNr+1;
    TempFinger.Template.PID=PID;

    memset((char*)&Template1,0,sizeof(Template1));
    memset((char*)&Template2,0,sizeof(Template2));
    Template1 = TempFinger.Template;

//nur Test
    //bertragen von Template in TemplatebufferA des Fingerprintmoduls
    if (!DFBSetTemplate  ( (unsigned char*)&Template1,  0)) error = DFBGetLastErrorNum();

    BufferLength = Templatesize;
    //bertragen von Template aus TemplatebufferA des Fingerprintmoduls
    if (!DFBGetTemplate  ( &BufferLength, (unsigned char*)&Template2)) error = DFBGetLastErrorNum();

    Result = memcmp(&Template1,&Template2,11);
    if (Result != 0)
    {
      error = 10;
    }
//Ende Test

    BufferLength=Templatesize;
    if (!DFBWriteTemplate(c_PID, &c_FID, (unsigned char*)&Template1 , &BufferLength )) error = DFBGetLastErrorNum();

//Nur Test
    BufferLength=Templatesize;
    if (!DFBReadTemplate(c_PID,0, c_FID, (unsigned char*)&Template2 , &BufferLength )) error = DFBGetLastErrorNum();

    Result = memcmp(&Template1,&Template2,11);
    if (Result != 0)
    {
      error = 10;
    }
//Ende Test      
  }

}
