// Demo2Dlg.cpp : Implementierungsdatei
//

#include "stdafx.h"
#include "Demo2.h"
#include "Demo2Dlg.h"
#include "DlgBestFinger.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CDemo2Dlg Dialogfeld

// Statische Membervariable fuer Zugriff ueber statische Methoden auf diese Klasse
CDemo2Dlg *CDemo2Dlg::m_this = NULL;

CDemo2Dlg::CDemo2Dlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDemo2Dlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDemo2Dlg)
	m_out = _T("");
	//}}AFX_DATA_INIT
	// Beachten Sie, dass LoadIcon unter Win32 keinen nachfolgenden DestroyIcon-Aufruf bentigt
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDemo2Dlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDemo2Dlg)
	DDX_Control(pDX, IDC_PROGRESS, m_progress);
	DDX_Text(pDX, IDC_OUT, m_out);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDemo2Dlg, CDialog)
	//{{AFX_MSG_MAP(CDemo2Dlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_CLOSE()
	ON_COMMAND(ID_FIRMWAREUPDATE, OnFirmwareupdate)
	ON_COMMAND(ID_BEST_FINGER, OnBestFinger)
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_THREAD, OnThread)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDemo2Dlg Nachrichten-Handler

BOOL CDemo2Dlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Symbol fr dieses Dialogfeld festlegen. Wird automatisch erledigt
	//  wenn das Hauptfenster der Anwendung kein Dialogfeld ist
	SetIcon(m_hIcon, TRUE);			// Groes Symbol verwenden
	SetIcon(m_hIcon, FALSE);		// Kleines Symbol verwenden
	
	// Fuer Statische Zugriffe auf diese Klasse
	m_this = this;

	return TRUE;  // Geben Sie TRUE zurck, auer ein Steuerelement soll den Fokus erhalten
}

// Wollen Sie Ihrem Dialogfeld eine Schaltflche "Minimieren" hinzufgen, bentigen Sie 
//  den nachstehenden Code, um das Symbol zu zeichnen. Fr MFC-Anwendungen, die das 
//  Dokument/Ansicht-Modell verwenden, wird dies automatisch fr Sie erledigt.

void CDemo2Dlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // Gertekontext fr Zeichnen

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Symbol in Client-Rechteck zentrieren
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Symbol zeichnen
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// Die Systemaufrufe fragen den Cursorform ab, die angezeigt werden soll, whrend der Benutzer
//  das zum Symbol verkleinerte Fenster mit der Maus zieht.
HCURSOR CDemo2Dlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDemo2Dlg::OnClose() 
{
	// Wird derzeit noch ein Befehl abgearbeitet?
	if (theApp.m_threadCommand != CDemo2App::idle) {
		
		AfxMessageBox("Es ist noch eine Befehlsausfhrung aktiv.");
		return;
	}
	
	CDialog::OnClose();
}

/*############################################################################*/
//  FUNKTION:	 OnThread
/** Abfangen der Windowsmessage WM_THREAD.

Autor                 : Bernd Ottmann             @n
erstellt am           : 15.07.2008                @n

@return Gibt immer TRUE zurck.

@b AUFGABE:    

- Abfangen der Windowsmessage WM_THREAD und ausfhren der gegebenen Rckmeldung.

@b KOMMENTARE:

@b NDERUNG:

@b LAUFZEIT :

@b TEST :

*/
/*############################################################################*/

LRESULT CDemo2Dlg::OnThread(WPARAM wParam, LPARAM lParam)
{
	switch(wParam) {
	case MSG_QUESTION: // Nachrichtenbox mit Frage anzeigen
		return AfxMessageBox((char*)lParam, MB_ICONQUESTION|MB_YESNO);
		break;

	case MSG_PROGRESS: // Fortschrittsbalken setzen
		m_progress.SetPos(lParam);
		break;

	case MSG_COMMAND_START: // Ausfuehrung eines Kommunikationsbefehls gestartet
		GetDlgItem(IDC_OUT)->EnableWindow(FALSE);
		break;

	case MSG_COMMAND_STOP: // Ausfuehrung eines Kommunikationsbefehls beendet
		GetDlgItem(IDC_OUT)->EnableWindow(TRUE);
		break;

	case MSG_INFORMATION: { // Zeichenfolge in Output uebernehmen (Information)

		m_out.Format("INFO: %s", (char*)lParam);
		UpdateData(FALSE);
		break;}

	case MSG_EXCLAMATION: { // Zeichenfolge in Output uebernehmen (Exclamation)

		m_out.Format("WARNUNG: %s", (char*)lParam);
		break;}

	case MSG_STOP: { // Zeichenfolge in Output uebernehmen (Stop)

		m_out.Format("FEHLER: %s", (char*)lParam);
		break;}

	default:
		TRACE("CDemo2Dlg::OnThread: Nicht eingetragene Threadmessage.\n");
	}

	return TRUE;
}

/*############################################################################*/
//  FUNKTION:	 CBFunction
/** CallBack-Funktion fr Fortschrittsbalken.

Autor                 : Bernd Ottmann             @n
erstellt am           : 15.07.2008                @n

@param[in] pos Prozentangabe der aktuell abgearbeiteten Aufgabe.
@return Gibt immer 1 zurck.

@b AUFGABE:    

- Umwandlung des CallBack-Ereignisses zu einer Fensternachricht um einen Fortschrittsbalken
  fr die Kommunikationsvisualisierung betreiben zu knnen.

@b KOMMENTARE:
- Der Fensterhandle mu vom Befehlsdialog vor Befehlsvergabe gesetzt werden,
  wenn er ber den Befehlsablauf informiert werden soll.

@b NDERUNG:

@b LAUFZEIT :

@b TEST :

*/
/*############################################################################*/

int CDemo2Dlg::CBFunction(int pos)
{
	// Nachricht von DLL an Nachrichtenverarbeitung des Dialogs weiterleiten
	::PostMessage(m_this->GetSafeHwnd(), WM_THREAD, MSG_PROGRESS, pos);
	return 1;
}

// Menuebefehl Firmwareupdate verarbeiten
void CDemo2Dlg::OnFirmwareupdate() 
{
	// Wird derzeit noch ein Befehl abgearbeitet?
	if (theApp.m_threadCommand != CDemo2App::idle) {
		
		AfxMessageBox("Es ist noch eine Befehlsausfhrung aktiv.");
		return;
	}
	
	// Auswahl einer Datei.
	CFileDialog FDlg(TRUE, "ini", NULL, OFN_HIDEREADONLY);
	char szFilter[] = "Update Biokey3000 ( *.upd )\0*.upd\0Alle Dateien ( *.* )\0*.*\0\0";
	char szInitialDir[MAX_PATH];
	strcpy(szInitialDir, ".\\");
	
	FDlg.m_ofn.lpstrTitle = "Datei fr Update ffnen.";
	FDlg.m_ofn.lpstrFilter = szFilter;
	FDlg.m_ofn.lpstrInitialDir = szInitialDir;
	
	// Dateiname abfragen
	if (FDlg.DoModal() == IDCANCEL) {
		
		return;
	}
	
	// Dateiname bernehmen
	m_filePath = FDlg.GetPathName();  
	
	// Befehl an Workerthread der Anwendung abgeben
	//----------------------------------------------
	// Zeiger auf diesen Dialog, damit im Workerthread auf die Memebervariablen zugegriffen wird.
	theApp.m_pDlg = this;
	// Handle auf das Fenster, damit im Workerthread Nachrichten an dieses gesendet werden.
	theApp.m_hWnd = GetSafeHwnd();
	// Den abzuarbeitenden Befehl an den Workerthread abgeben.
	theApp.m_threadCommand = CDemo2App::Firmwareupdate;
}

// Menubefehl BestFinger abarbeiten
void CDemo2Dlg::OnBestFinger() 
{
	// Aufgabe an Unterdialog abgeben
	CDlgBestFinger dlg;
	dlg.DoModal();
}





